//**********************************************//
//******************KAmodMEMS2******************//
//**********************************************//

//W folderze do ktrego rozpakujemy archiwum z niniejszym programem(ZIP) musi 
//znajdowac sie folder z biblioteka "STM32F10x_StdPeriph_Lib_V3.5.0"
//w celu poprawnej kompilacji programu.

//Do dzialania programu potrzebny jest modul KAmod TFT2
//polaczenia do wykonania pomiedzy modulem a zestawem ZL27ARM

//****************ZL27ARM - KAmodTFT2*****************//  
//JP6 PA4           <-> Con1 SCE
//JP6 PA5           <-> Con1 CLK
//JP6 PA7           <-> Con1 DIN
//JP6 PA8           <-> Con1 RES
//JP6 GND           <-> Con1 GND
//JP6 +3,3V (GPIOB) <-> Con1 +V


//**************KAmodMEMS2 - ZL27ARM*************//
//Con1_SCL - JP5(PB6)
//Con1_SDA - JP5(PB7)
//Con1_+V - JP5(+3.3V)
//Con1_GND - JP5(GND)

//****************ZL27ARM - ZL27ARM*****************//
//JP5(PB15) - JP7(SPK)


#include "stm32f10x.h"
#include "Inicjalizacja.h"
#include "lis35.h"
#include "tft_pcf8833_lib.h"
#include "tarcza.h"
#include "kulka.h"
#include "font1.h"
#include "font2.h"
#include "Sprzet.h"

#include "stdio.h"
#include "stdlib.h"
#include "math.h"

void Info(void);

int main(void)
{
  volatile unsigned long int i;
	signed char x,y,kx,ky;
	short petla,czas;
	
	//Konfiguracja systemu
	RCC_Configuration();
  NVIC_Configuration();
	GPIO_Configuration();
		
	LIS35_Configuration();
	
	//Wylaczenie LED
	GPIO_ResetBits(LED_PORT, LED1 | LED2 | LED3 | LED4 | LED5 | LED6 | LED7 | LED8);	
	
	TFTN_HwConfig();
  TFTN_Init();
	
	//Bialy obraz
	TFTN_Clear(0xFFF);
	//Tekst "Inicjalizacja" na TFT
  TFTN_WriteXY("Inicjalizacja\0" ,  5, 10,0xF00,0xFFF, font2);
	//Inicjalizacja LIS35
	if (LIS35_Initialize()) TFTN_Clear(0xF00);	
	//Rysowanie tarczy poziomicy na TFT
	TFTN_WriteBMP(tarcza);	

	while(1)
	{
  
	//Wartosc przyspieszenia x	
	LIS35_ReadRegister(0x29,&x);
	//Wartosc przyspieszenia y
	LIS35_ReadRegister(0x2B,&y);
		
	//Ograniczenie maksymalnego przyspieszenia(przechylenia)
	if(x<(-53)) x=-53;
	if(y<(-53)) y=-53;
	if(x>53) x=53;
	if(y>53) y=53;
		
	//Obliczenie wspolrzednych kulki	
	kx=53+x;//kx=53+x(+-)offset
	ky=53+y;//ky=53+y(+-)offset
		
	//Przerenderowanie wylacznie obrazu kulki	
	TFTN_WriteBall(tarcza,kulka, kx, ky, 26, 26);	
	
	//Opcjonalne opuznienie	
	for(petla=0;petla<100;petla++);		
		
		//Jesli wykryto poziom w osi x
		if(kx<56&&kx>50)
		{
			//Jesli wykryto poziom w osi y
			if(ky<56&&ky>50)
			{
				for(petla=0;petla<100;petla++)
				{
					for(czas=0;czas<1000;czas++);
					  //Dzwiek na GPIOB 15 (podlaczyc buzzer)
						GPIO_WriteBit(GPIOB, GPIO_Pin_15, (BitAction)(1-GPIO_ReadOutputDataBit(GPIOB, GPIO_Pin_15)));			
				}
			}
		}
	}
};

  


		
	
  


						   
